#include <sd_v0_01.h>

unsigned char sd_init(void)
{
	SET_BIT(DDR_SD, SD_DI);
	SET_BIT(DDR_SD, SD_CLK);
	SET_BIT(DDR_SD, SD_CS);		// Ausgnge
	CLEAR_BIT(DDR_SD, SD_DO);	// Eingang

	_delay_ms(10);

	SET_BIT(POUT_SD, SD_CS);
	SET_BIT(POUT_SD, SD_DI);

	// Min. 74 Dummy Clocks)
	int i;
	for(i=0; i<=24; i++)
	{
		sd_write_byte(0xFF);
	}
	unsigned char Timeout=0;
	cmd[0] = CMD0;
	cmd[1] = 0;
	cmd[2] = 0;
	cmd[3] = 0;
	cmd[4] = 0;
	cmd[5] = 0x95;
	while(sd_send_command(cmd) !=1)
	{
		if (Timeout++ > 200)
			{
			printf("CMD0 NICHT erfolgreich");
			SET_BIT(POUT_SD, SD_CS);
			return(1);
			}
	}

	cmd[0] = CMD1;
	cmd[1] = 0;
	cmd[2] = 0;
	cmd[3] = 0;
	cmd[4] = 0;
	cmd[5] = 0xFF;
	while(sd_send_command(cmd) !=0)
	{
		if (Timeout++ > 400)
			{
			printf("CMD1 NICHT erfolgreich");
			SET_BIT(POUT_SD, SD_CS);
			return(1); 
			}
	}


	return 0;		// Init ohne Fehler ausgefhrt
}







//----------------------------------------
void sd_write_byte(unsigned char write_byte)
{
	CLEAR_BIT(POUT_SD, SD_CLK);
	int i;
	for(i=7; i>=0;i--)
	{
		// Bit schreiben 
		if (write_byte & (1 << i))
		{
			SET_BIT(POUT_SD, SD_DI);		
		}
		else
		{
			CLEAR_BIT(POUT_SD, SD_DI);
		}
		// 
		SET_BIT(POUT_SD, SD_CLK);
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		CLEAR_BIT(POUT_SD, SD_CLK);
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
	}
}
//----------------------------------------
unsigned char sd_read_byte(void)
{
	unsigned char read = 0xFF;
	CLEAR_BIT(POUT_SD, SD_CLK);
	int i;
	for(i=7; i>=0;i--)
	{
		SET_BIT(POUT_SD, SD_CLK);
		nop();
		nop();
		nop();
		// Bit lesen 
		if (PIN_SD & (1 << SD_DO))
		{
			SET_BIT(read, i);		
		}
		else
		{
			CLEAR_BIT(read, i);
		}
		// 
	
		nop();
		nop();
		nop();
		CLEAR_BIT(POUT_SD, SD_CLK);
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
	}
	return read;
}

//----------------------------------------


unsigned char sd_send_command(volatile unsigned char *cmd)
{
	SET_BIT(POUT_SD, SD_CS);
	volatile unsigned char read =0xFF;
	sd_write_byte(0xFF);		// Dummy Read fr SD-karte	
	CLEAR_BIT(POUT_SD, SD_CS);			

	unsigned char i;
	for(i=0; i<=5; i++)
	{
		sd_write_byte(*cmd++);
	}
	unsigned char Timeout=0;
	read = sd_read_byte();
	while (read == 0xFF)
	{
		read = sd_read_byte();
		if (Timeout++ > 500)		
		{
			printf("Timeout in Send Command");
			break;
		}
	}
	printf("Read ");
	printf("%x", read); 
	return read;
}





